Summary:        Perl compatible regular expression library
Name:           pcre
Version:        8.45
Release:        3%{?dist}
License:        BSD
URL:            https://www.pcre.org/
Source0:        https://sourceforge.net/projects/%{name}/files/%{name}/%{version}/%{name}-%{version}.tar.gz
Patch3000:      pcre-8.41-fix_stack_estimator.patch
Patch3001:      pcre-8.21-multilib.patch
Patch3002:      pcre-8.42-Declare-POSIX-regex-function-names-as-macros-to-PCRE.patch
Patch3003:      pcre-8.44-Inicialize-name-table-memory-region.patch
Patch3004:      pcre-8.44-JIT-compiler-update-for-Intel-CET.patch
Patch3005:      pcre-8.44-Pass-mshstk-to-the-compiler-when-Intel-CET-is-enable.patch

BuildRequires:  make libtool autoconf automake gcc gcc-c++ coreutils
BuildRequires:  readline-devel

%description
The PCRE library is a set of functions that implement regular expression pattern matching
using the same syntax and semantics as Perl 5. PCRE has its own native API, as well as 
a set of wrapper functions that correspond to the POSIX regular expression API.

This version of PCRE is now at end of life, and is no longer being actively maintained.
Version 8.45 is expected to be the final release of the older PCRE library,
and new projects should use PCRE2 instead.

PCRE html documents is https://www.pcre.org/original/doc/html/.


%package utf16
Summary:        UTF-16 form of PCRE

%description utf16
Perl compatible regular expression library workis on UTF-16 strings.


%package utf32
Summary:        UTF-32 form of PCRE

%description utf32
Perl compatible regular expression library workis on UTF-32 strings.


%package cpp
Summary:        C++ bindings for PCRE
Requires:       %{name} = %{version}-%{release}

%description cpp
C++ bindings for the Perl compatible regular expression library.


%package devel
Summary:        Development files for PCRE
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-cpp = %{version}-%{release}
Requires:       %{name}-utf16 = %{version}-%{release}
Requires:       %{name}-utf32 = %{version}-%{release}

%description devel
Headers and libraries  for pcre.


%package static
Summary:        Static library for PCRE
Requires:       %{name}-devel = %{version}-%{release}

%description static
Static library for pcre.


%package tools
Summary:        Utilities for PCRE
Requires:       %{name} = %{version}-%{release}

%description tools
Utilities demonstrating PCRE capabilities like pcregrep or pcretest.


%prep
%autosetup -n %{name}-%{version} -N
%patch3000 -p2
%autopatch -m 3001 -M 3005 -p1


%build
autoreconf -vif
%configure --enable-jit \
           --enable-pcretest-libreadline \
           --enable-utf \
           --enable-unicode-properties \
           --enable-pcre8 \
           --enable-pcre16 \
           --enable-pcre32 \
           --disable-silent-rules
%make_build


%install
%make_install
rm -rf %{buildroot}%{_libdir}/*.la
rm -rf %{buildroot}%{_docdir}/pcre


%check
%make_build check


%files
%license COPYING LICENCE
%doc AUTHORS NEWS ChangeLog README
%{_libdir}/libpcre.so.1
%{_libdir}/libpcre.so.1.*
%{_libdir}/libpcreposix.so.0
%{_libdir}/libpcreposix.so.0.*

%files utf16
%license COPYING LICENCE
%doc AUTHORS NEWS ChangeLog README
%{_libdir}/libpcre16.so.0
%{_libdir}/libpcre16.so.0.*

%files utf32
%license COPYING LICENCE
%doc AUTHORS NEWS ChangeLog README
%{_libdir}/libpcre32.so.0
%{_libdir}/libpcre32.so.0.*

%files cpp
%{_libdir}/libpcrecpp.so.0
%{_libdir}/libpcrecpp.so.0.*

%files devel
%doc README HACKING pcredemo.c
%doc doc/*.txt doc/html
%{_bindir}/pcre-config
%{_libdir}/*.so
%{_libdir}/pkgconfig/*
%{_includedir}/*.h
%{_mandir}/man1/pcre-config.*
%{_mandir}/man3/*

%files static
%license COPYING LICENCE
%{_libdir}/*.a

%files tools
%{_bindir}/pcregrep
%{_bindir}/pcretest
%{_mandir}/man1/pcregrep.*
%{_mandir}/man1/pcretest.*


%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.45-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.45-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Jun 27 2022 rockerzhu <rockerzhu@tencent.com> - 8.45-1
- Initial build
